pipeline {
  agent {
    node {
      label 'master'
    }

  }
  stages {
    stage('Checkout') {
      steps {
        echo 'Begin checkout project'
        script {
          def ROOT = "/var/www/jenkins/${params.APPLICATION_NAME}"

          if (!fileExists("${ROOT}")) {
            sh "mkdir -p ${ROOT}"
            sh "cp /etc/httpd/sites-enabled/laravel.template  /etc/httpd/sites-enabled/${params.APPLICATION_NAME}.conf"
            sh "sed -i 's#DOCUMENT_ROOT#${ROOT}#g' /etc/httpd/sites-enabled/${params.APPLICATION_NAME}.conf"
            sh "sed -i 's#URL#${BASE_URL}#g' /etc/httpd/sites-enabled/${params.APPLICATION_NAME}.conf"
            sh "service httpd restart"
          }
        }
      }
    }
    stage('Build') {
      steps {
        echo 'Begin build source code'
      }
    }
    stage('Unit Test') {
      steps {
        echo 'Begin do unit test'
      }
    }
    stage('Artifacts ') {
      steps {
        echo 'Begin do Artifacts'
      }
    }
    stage('Deployment') {
      steps {
        echo 'Begin do deployment'
        script {
          def ROOT = "/var/www/jenkins/${params.APPLICATION_NAME}/"
          def env = "${params.ENV}"
          if (!env) {
            env = 'staging'
          }
          sh "cp .env.${env} ${ROOT}.env"
          sh "rsync -arv ./* ${ROOT}"
          sh "chown -R root:root ${ROOT}"
          sh "rm -rf ${ROOT}.env.production.php"
          sh "rm -rf ${ROOT}.env.staging.php"
          dir("${ROOT}"){
            sh "composer config github-oauth.github.com 39ad6f9d5fe4e5299c120697be2667b4bb05b9ca"
            sh "composer install"
          }
        }

        emailext(body: "Complete Build on ${params.BASE_URL}", recipientProviders: [[$class: 'DevelopersRecipientProvider'], [$class: 'RequesterRecipientProvider']], subject: "Complete Build on ${params.BASE_URL}")
      }
    }
  }
  parameters {
    string(name: 'APPLICATION_NAME', defaultValue: 'fimeapi')
    string(name: 'DB_HOST', defaultValue: '192.168.181.40')
    string(name: 'DB_NAME', defaultValue: 'Custom_Fime')
    string(name: 'DB_USERNAME', defaultValue: 'netpower')
    string(name: 'DB_PASSWORD', defaultValue: 'webPower2010')
    string(name: 'BASE_URL', defaultValue: 'fimeapi.vn-php.netpower.lan')
    choice(name: 'ENV', choices: ['staging', 'production', 'local'], description: 'Select environment')
  }
}